# coding: utf-8

"""
    Project Service API

    Project Service exposes a REST API, providing access to operations with projects Example: 1. `$orderby` - Sorting criteria in the format: property (asc | desc). Default sort order is ascending.     ```/project-service/api/projects?$orderby=name%20desc``` 2. `$top` -  limits the requested number of resources.     ```/project-service/api/projects?$top=10``` 3. `$skip` -  client can skip a given number of resources.      ```/project-service/api/projects?$skip=2``` 4. `$top` & `$skip` - used in conjunction helps in pagination of resources        ```/project-service/api/projects?$top=10&$skip=2``` 5. `$filter` -  returns a subset of resources that satisfy the given predicate expression.     ```/project-service/api/projects?$filter=startswith(name, 'Test')```  # noqa: E501

    OpenAPI spec version: 2020-08-10
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class InlineResponse2006(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'user_roles': 'list[str]',
        'user_permissions': 'list[str]',
        'projects': 'list[AuthContextProjects]'
    }

    attribute_map = {
        'user_roles': 'userRoles',
        'user_permissions': 'userPermissions',
        'projects': 'projects'
    }

    def __init__(self, user_roles=None, user_permissions=None, projects=None):  # noqa: E501
        """InlineResponse2006 - a model defined in Swagger"""  # noqa: E501
        self._user_roles = None
        self._user_permissions = None
        self._projects = None
        self.discriminator = None
        if user_roles is not None:
            self.user_roles = user_roles
        if user_permissions is not None:
            self.user_permissions = user_permissions
        if projects is not None:
            self.projects = projects

    @property
    def user_roles(self):
        """Gets the user_roles of this InlineResponse2006.  # noqa: E501

        A list of roles that the user has at organization level  # noqa: E501

        :return: The user_roles of this InlineResponse2006.  # noqa: E501
        :rtype: list[str]
        """
        return self._user_roles

    @user_roles.setter
    def user_roles(self, user_roles):
        """Sets the user_roles of this InlineResponse2006.

        A list of roles that the user has at organization level  # noqa: E501

        :param user_roles: The user_roles of this InlineResponse2006.  # noqa: E501
        :type: list[str]
        """

        self._user_roles = user_roles

    @property
    def user_permissions(self):
        """Gets the user_permissions of this InlineResponse2006.  # noqa: E501

        A list of permissions that the user has at organization level  # noqa: E501

        :return: The user_permissions of this InlineResponse2006.  # noqa: E501
        :rtype: list[str]
        """
        return self._user_permissions

    @user_permissions.setter
    def user_permissions(self, user_permissions):
        """Sets the user_permissions of this InlineResponse2006.

        A list of permissions that the user has at organization level  # noqa: E501

        :param user_permissions: The user_permissions of this InlineResponse2006.  # noqa: E501
        :type: list[str]
        """

        self._user_permissions = user_permissions

    @property
    def projects(self):
        """Gets the projects of this InlineResponse2006.  # noqa: E501

        A list of projects this user is a member of  # noqa: E501

        :return: The projects of this InlineResponse2006.  # noqa: E501
        :rtype: list[AuthContextProjects]
        """
        return self._projects

    @projects.setter
    def projects(self, projects):
        """Sets the projects of this InlineResponse2006.

        A list of projects this user is a member of  # noqa: E501

        :param projects: The projects of this InlineResponse2006.  # noqa: E501
        :type: list[AuthContextProjects]
        """

        self._projects = projects

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InlineResponse2006, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InlineResponse2006):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
